class Kohonen
  {
   private:
      int   ImageW,ImageH ;//     
      bool  Show ;//          
      int   sizeX,sizeY;//    ,   
      double   MinVector[];//      
      double   MaxVector[];//       
      bool  FirstMinMax;//           
      int   CelsX,CelsY;//        
      int   m_iter ;// -  
      double radius;//             
      double FerstRadius;//   
      double m_learning_rate;//   
      long  ident ;//        
      struct s_vek //    
        {
            double indata[];//    
            int cnttich;//        
        };
      s_vek   TichVector[];//   
      struct s_ney
        {//    
            double   sinaps[] ;//  
            double   outsign;//  
            bool     papil;//          
            int      CntLockTich; //      
                     //    CntLockTich=0 
            int      CntGood;//       
            bool     rest;//    
            int      x,y ;//       
            color    clr;//    
            int      mapX, mapY;//      
            string   name;//   OBJ_RECTANGLE_LABEL                  
        };
      s_ney Neyron[];//       
   public:
      //Kohonen();// 
      //~Kohonen();// 
      void  AddTichVector(double &in[]);//     
      //void  SetSizeDisp(int x,int y){ImageW=x;ImageH=y;};//     
      //void  SetSizeMap(int x,int y){CelsX=x;CelsY=y;};//    
      void  Init(int iter,int wid,int high,int clx,int cly,bool sh=false);//  iter - , wid    
                  // high    , clx    , cly    
      void  Train();//   
   protected:
      void  FindMinMax();//         
      void  InitNeyron();//  
      int   GetMinOut(double &invector[]);//        
      void  ShowMap();//      
      void  ShowMaping();//       
           
  };
//==========================================================================================
void  Kohonen::Init(int iter,int wid,int high,int clx,int cly,bool sh=false )
   {
      m_iter=iter ; ImageW=wid ; ImageH=high ; CelsX=clx; CelsY=cly;
      if (CelsX >=CelsY) radius=CelsX/2 ; else radius=CelsY/2 ;
      FerstRadius=m_iter/MathLog(radius);//        
      m_learning_rate=0.1;//     
      Show=sh ;//       
      long  ident=ChartID() ;//        
      MathSrand(1);
   };
//==========================================================================================
void Kohonen::AddTichVector(double &in[])// in   
   {//     
      int size=ArraySize(TichVector);
      int sizein=ArraySize(in);//
      int i ;
      ArrayResize(TichVector,size+1,0);//    
      TichVector[size].cnttich=0 ;//       
      ArrayResize(TichVector[size].indata,sizein);
      for( i=0;i<sizein;i++)//  
        { TichVector[size].indata[i]=in[i]; 
          if(!FirstMinMax)//     
            {//    
              ArrayResize(MaxVector,sizein) ;
              ArrayResize(MinVector,sizein) ;
              MaxVector[i]=in[i];//        
              MinVector[i]=in[i]; 
            }
        }
        FirstMinMax=true ;//      
   };
//=========================================================================
void  Kohonen::FindMinMax(void)
   {//               -1 1
      int size=ArraySize(TichVector);//  -  
      int sizevec=ArraySize(TichVector[size-1].indata);//   
      int i,j ;
      double   aaa;
      for( i=0;i<size;i++)
        {//     
            for( j=0;j<sizevec;j++)
              {
                  if(MaxVector[j]<TichVector[i].indata[j])
                     MaxVector[j]=TichVector[i].indata[j];
                  if(MinVector[j]>TichVector[i].indata[j])
                     MinVector[j]=TichVector[i].indata[j];
              }
        }
//     ,       
//  0 100  -50 150
      for( i=0;i<sizevec;i++)
        {
            aaa=(MaxVector[i]-MinVector[i])/2 ;
            MaxVector[i]+=aaa ;
            MinVector[i]-=aaa ;
        }
      for( i=0;i<size;i++)
        {//    -1  1  
            for( j=0;j<sizevec;j++)
              {
                  TichVector[i].indata[j]=(TichVector[i].indata[j]-MinVector[j])/
                                          (MaxVector[j]-MinVector[j]);
              }
        }
   };
//=================================================================================================================
void  Kohonen::InitNeyron(void)
   {//   
      int i,j,k,sizsin;
      sizsin=ArraySize(MinVector) ;//      
      ArrayResize(Neyron,CelsX*CelsY);//     
      //int sizeX;//      
      //int sizeY ;//       
      string   name;
      sizeX=int(ImageW/CelsX) ;//      
      sizeY=int(ImageH/CelsY) ;//       
      for( i=0;i<CelsY;i++)
        {
            for( j=0;j<CelsX;j++)
              {
               Neyron[i*CelsX+j].CntGood=0 ;//       
               Neyron[i*CelsX+j].CntLockTich=0;//      
                     //    CntLockTich=0 
               Neyron[i*CelsX+j].clr=clrNONE ;//   
               Neyron[i*CelsX+j].mapX=j*sizeX ;
               Neyron[i*CelsX+j].mapY=i*sizeY ;//     
               Neyron[i*CelsX+j].outsign=0 ;//  
               Neyron[i*CelsX+j].rest=false ;//         
               ArrayResize(Neyron[i*CelsX+j].sinaps,sizsin) ;//    
               //ind=int(CelsX*CelsY*MathRand()/32768);//        
               //Print("     =  ",ind);
               for(k=0;k<sizsin;k++)//    
                 Neyron[i*CelsX+j].sinaps[k]=2*MathRand()/32767-1 ;     
               Neyron[i*CelsX+j].x=j ;
               Neyron[i*CelsX+j].y=i ;//     
               name="My"+IntegerToString(i*CelsX+j) ;//   OBJ_RECTANGLE_LABEL   
               Neyron[i*CelsX+j].name=name ; 
               Neyron[i*CelsX+j].papil=false ;
              }
        }
   }
//=======================================================================================================
int   Kohonen::GetMinOut(double &invector[])
   {//        
      bool  fistcalc=false ;
      int i,j,Index;
      double   aaa=0,MinOut ;
      int sizesin=ArraySize(MinVector) ;//    
      int sizeneyr=ArraySize(Neyron);//      
      for( i=0;i<sizeneyr;i++)
        {
            aaa=0 ;
            for(j=0;j<sizesin;j++)
              {//             
                  aaa+=pow(Neyron[i].sinaps[j]-invector[j],2);       
              } 
            if(!fistcalc && !Neyron[i].rest)
               {//                
                  MinOut=MathSqrt(aaa) ;
                  Index=i ;
                  fistcalc=true ;
                  continue ;
               }
            if(MinOut > MathSqrt(aaa) && !Neyron[i].rest)
              {//           
              //         
               MinOut=MathSqrt(aaa) ;
               Index=i ;
              }
        }
        return(Index);//         
   };
//==========================================================================================================
void  Kohonen::Train(void)
   {//    
      double   vector[],distance; 
      int iter,ind,i,j;
      int BestNeyron;//   
      int QuantTichVector=ArraySize(TichVector);//  -   
      double influence;//
      double ws;//       
      double neighbourhood_radius;//  
      double learning_rate=m_learning_rate;
//----------------------------------------------------------------------------------------------------------------------
      InitNeyron();//   
      FindMinMax();//      -1 1
      //Print("======    =======");
      //ShowMaping();
     for(iter=0 ;iter< m_iter; iter++)
      {   
      ind=int(QuantTichVector*MathRand()/32768);//        
      int size=ArraySize(TichVector[ind].indata);//       
      ArrayResize(vector,size,0);
      for(i=0;i<size;i++)
           vector[i]=TichVector[ind].indata[i];//   
      BestNeyron=GetMinOut(vector);//        
      Neyron[BestNeyron].CntGood++ ;//   
      Neyron[BestNeyron].papil=true ;//     
      if(Neyron[BestNeyron].CntGood > 3) Neyron[BestNeyron].rest=true ;//       
      int sizeneyr=ArraySize(Neyron);//  -
      for(j=0;j<sizeneyr;j++)
        {
            if(Neyron[j].rest) Neyron[j].CntLockTich++ ;//       
            if(Neyron[j].rest && Neyron[j].CntLockTich >40)
               {//   40       
                  Neyron[j].rest=false ;
                  Neyron[j].CntLockTich=0 ;
                  Neyron[j].CntGood=0 ;
               }
        }
      for( i=0;i<sizeneyr;i++)
        {//             
            distance=sqrt(pow(Neyron[i].x-Neyron[BestNeyron].x,2)+pow(Neyron[i].y-Neyron[BestNeyron].y,2));//    
            neighbourhood_radius=radius*MathExp(-1.0*iter/FerstRadius);// 
            ws=pow(neighbourhood_radius,2);//    
            if(distance < ws)
               {//          
                  influence=MathExp(-distance/(2*ws)); //     
                  for(j=0;j < size ;j++)
                     {//       
                        Neyron[i].sinaps[j]=Neyron[i].sinaps[j]+influence*learning_rate*(TichVector[ind].indata[j]-Neyron[i].sinaps[j]);
                     }
                  learning_rate=m_learning_rate*MathExp(-1.0*iter/m_iter); //  ( iter)   
               }
        }
        if(iter%2==0 && Show) //          N- 
	      {//   
	         //Print("------------   --------");
			   ShowMaping();
	      }
      }
           ShowMaping();  
   }
//========================================================================================================================================
Kohonen::ShowMap(void)
   {//    ( )
      int size=ArraySize(Neyron);//      
      int i;
      for(i=0;i<size ;i++)
         {//    
           if(ObjectFind(ident,Neyron[i].name) <0 )
               {//        
                  ObjectCreate(ident,Neyron[i].name,OBJ_RECTANGLE_LABEL,0,0,0);//    
                  ObjectSetInteger(ident,Neyron[i].name,OBJPROP_XSIZE,sizeX);//    
                  ObjectSetInteger(ident,Neyron[i].name,OBJPROP_YSIZE,sizeY);//    y
                  ObjectSetInteger(ident,Neyron[i].name,OBJPROP_XDISTANCE,Neyron[i].mapX);//  
                  ObjectSetInteger(ident,Neyron[i].name,OBJPROP_YDISTANCE,Neyron[i].mapY);// y  
                  ObjectSetInteger(ident,Neyron[i].name,OBJPROP_BORDER_TYPE,BORDER_FLAT);//  
                  ObjectSetInteger(ident,Neyron[i].name,OBJPROP_BGCOLOR,Neyron[i].clr);//  
                  ObjectSetInteger(ident,Neyron[i].name,OBJPROP_COLOR,Neyron[i].clr);//      
               }
             else
               {
                  ObjectSetInteger(ident,Neyron[i].name,OBJPROP_BGCOLOR,Neyron[i].clr);// 
                  ObjectSetInteger(ident,Neyron[i].name,OBJPROP_COLOR,Neyron[i].clr);//                
               }
         }
   }
//=============================================================================================================================
void  Kohonen::ShowMaping(void)
   {//             
      double min,max,indiv,distance,sredn;
      bool  first=false ;
      int   size=ArraySize(Neyron);
      int   i,j,index,k,sizesinaps,cntsredn;   
      color color_mass[54]=
      {0x00000000,0x00090609,0x000D0B0D,0x00120F13,0x001C181D,0x00211E22,0x002B272C,0x00332F35,
       0x00342C38,0x00372D37,0x003A2938,0x003D2731,0x003C2828,0x003C3128,0x003D3C27,0x00363A29,
       0x002E3C28,0x0026442F,0x00263E3D,0x001D3647,0x00113253,0x000C2458,0x0006155E,0x00000064,
       0x00000080,0x0000008C,0x0000009B,0x00003DB9,0x000040C4,0x000044D2,0x00004BE8,0x000050F4,
       0x000657FF,0x002068FF,0x001562FF,0x001172F4,0x000971D9,0x000A7AEB,0x0064AEF9,0x001BAEF5,
       0x000AB1F1,0x001AD8F2,0x0021D9F3,0x0052E1F5,0x0033DCF4,0x0057E2F7,0x0061D1BB,0x0061D19E,
       0x0060D280,0x0072D88D,0x008BDEA2,0x00A6E6B8,0x00BBECC9,0x00C0E096
      };
      for(i=0;i<size ;i++)
         {//             
            //   
            cntsredn=0 ;
            sizesinaps=ArraySize(Neyron[i].sinaps);//    
            for(j=0;j<size;j++)
               {//
                  if(i == j) continue ;//       
                        distance=sqrt(pow(Neyron[i].x-Neyron[j].x,2)+pow(Neyron[i].y-Neyron[j].y,2));
                        if(distance <5) //    
                           {
                              cntsredn++;//      
                              sredn=0 ;
                              for(k=0;k<sizesinaps;k++)//           
                                    sredn+=pow(Neyron[i].sinaps[k]-Neyron[j].sinaps[k],2);
                              Neyron[i].outsign+=sqrt(sredn) ;
                           }                    
               }
            Neyron[i].outsign/=cntsredn ;//            
         }
         for(i=0;i<size;i++)
            {//      
               if (!first)
                  {//        
                     min=Neyron[i].outsign ;
                     max=Neyron[i].outsign ;
                     first=true ;
                     continue ;
                  }
               if(min >Neyron[i].outsign ) min=Neyron[i].outsign ;//       
               if(max <Neyron[i].outsign ) max=Neyron[i].outsign ;
            }
         indiv=(max-min)/(ArraySize(color_mass)-1);//   
      for(i=0 ;i< size ;i++)
         {//                
            index=int((Neyron[i].outsign-min)/indiv) ;
            Neyron[i].clr=color_mass[index];
            //             
            //if(!Neyron[i].papil) Neyron[i].clr=0x0000FF00;
         }   
         ShowMap();//    ( )
   }